var Optosense = require('../OptosenseBase.js');

module.exports =  function(RED) 
{
    function BatteryInfo(config) {
        RED.nodes.createNode(this, config);
        var node = this;

        node.on('input', function(msg, send, done) 
        {
            try
            {
                Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x71 /* DAStatus1 */, -1 /* Don't care */, 32 + 1 /*read block +1 because of receiveing block length...*/, function (Error, Data)
                {
                    msg.error |= Error;
                    if(Error === null)
                    {
                        msg.Cell1_Voltage_mV = Data.readInt16LE(1);
                        msg.Cell2_Voltage_mV = Data.readInt16LE(3);
                        msg.Cell3_Voltage_mV = Data.readInt16LE(5);
                        msg.Cell4_Voltage_mV = Data.readInt16LE(7);

                        msg.BAT_Voltage_mV = Data.readInt16LE(9);
                        msg.PACK_Voltage_mV = Data.readInt16LE(11);

                        msg.Cell1_Current_mA = Data.readInt16LE(13);
                        msg.Cell2_Current_mA = Data.readInt16LE(15);
                        msg.Cell3_Current_mA = Data.readInt16LE(17);
                        msg.Cell4_Current_mA = Data.readInt16LE(19);
                        
                        msg.Cell1_Power_cW = Data.readInt16LE(21);
                        msg.Cell2_Power_cW = Data.readInt16LE(23);
                        msg.Cell3_Power_cW = Data.readInt16LE(25);
                        msg.Cell4_Power_cW = Data.readInt16LE(27);
                        
                        msg.Voltage_x_Current_cW = Data.readInt16LE(29);
                        
                        msg.Average_Power_cW = Data.readInt16LE(31);
                    }
                    Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x0F /* Remaining_Capacity */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                    {
                        msg.error |= Error;
                        if(Error === null)
                        {
                            msg.Remaining_Capacity = Data.readInt16LE();
                        }
                        Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x10 /* Full_Charge_Capacity */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                        {
                            msg.error |= Error;
                            if(Error === null)
                            {
                                msg.Full_Charge_Capacity = Data.readInt16LE();
                            }
                            Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x11 /* Run_Time_To_Empty */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                            {
                                msg.error |= Error;
                                if(Error === null)
                                {
                                    msg.Run_Time_To_Empty = Data.readInt16LE();
                                    msg.Run_Time_To_Empty_String = Optosense.Misc.minsToHHMMSS(msg.Run_Time_To_Empty);
                                }
                                Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x12 /* Average_Time_To_Empty */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                                {
                                    msg.error |= Error;
                                    if(Error === null)
                                    {
                                        msg.Average_Time_To_Empty = Data.readInt16LE();
                                        msg.Average_Time_To_Empty_String = Optosense.Misc.minsToHHMMSS(msg.Average_Time_To_Empty);
                                    }
                                    Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x13 /* Average_Time_To_Full */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                                    {
                                        msg.error |= Error;
                                        if(Error === null)
                                        {
                                            msg.Average_Time_To_Full = Data.readInt16LE();
                                            msg.Average_Time_To_FullString = Optosense.Misc.minsToHHMMSS(msg.Average_Time_To_Full);
                                        }
                                        Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x14 /* Charging_Current */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                                        {
                                            msg.error |= Error;
                                            if(Error === null)
                                            {
                                                msg.Charging_Current = Data.readInt16LE();
                                            }
                                            Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x15 /* Charging_Voltage */, -1 /* Don't care */, 2 /*read word*/, function (Error, Data)
                                            {
                                                msg.error |= Error;
                                                if(Error === null)
                                                {
                                                    msg.Charging_Voltage = Data.readInt16LE();
                                                }
                                                Optosense.Core.CMD(Optosense.BUS.GAUGE, 0x20 /* Manufacturer_Name */, -1 /* Don't care */, 20 + 1 /*read block +1 because of receiveing block length...*/, function (Error, Data)
                                                {
                                                    msg.error |= Error;
                                                    if(Error === null)
                                                    {
                                                        var StringLen = Data.readInt8();
                                                        msg.Manufacturer_Name = Data.toString('utf8', 1, StringLen + 1);
                                                    }
                                
                                                    //Let's send the message on last transfer...
                                                    node.send(msg);
                                                });
                                            });
                                            
                                        });
                                    });
                                });
                            });
                        });
                    });
                });
            }
            catch(e)
            {
                console.error(e);
            }
        });
    }
    RED.nodes.registerType("BatteryInfo", BatteryInfo);
}