var Optosense = require('../OptosenseBase.js');


module.exports =  function(RED) 
{
    function SetVoltage(config) {
        RED.nodes.createNode(this, config);
        var node = this;
        node.on('input', function(msg) 
        {
            try            
            {
                var DeviceSelector = Optosense.BUS.Self;
                var enable = msg['enable'] || config.enable;
           
                var voltage = 0;
    
                if(config.voltage_type === 'flow')
                    voltage = this.context().flow.get(config.voltage) || '';
                else if(config.voltage_type === 'msg')
                    voltage = msg[config.voltage] || '';
                else if(config.voltage_type === 'global')
                    voltage = this.context().global.get(config.voltage) || '';
                else if(config.voltage_type === 'str')
                    voltage = config.voltage || '';
    
                if(voltage < 3000)
                    voltage = 3000;
                else if(voltage > 12000)
                    voltage = 12000;
                    
                console.log("Set PowerStage: " + voltage + "mV - " + (enable ? "ON" : "OFF"));
    
                Optosense.Core.CMD(DeviceSelector, enable ? Optosense.Command.ENABLE_5V_12V_POWER : Optosense.Command.DISABLE_5V_12V_POWER , 1, 1, function (Error, Data)
                {
                    msg.error |= Error;
                    msg.set_voltage = voltage;
                    
                    Optosense.Core.CMD(DeviceSelector, Optosense.Command.SET_5V_12V_POWER /* SET_5V_12V_POWER */, (parseInt(voltage) / 50), 1 , function (Error, Data)
                    {
                        msg.error |= Error;
                        node.send(msg);	
                    });	
                });
      
            }
            catch(e)
            {
                console.error(e);
            }
        });
    }
    RED.nodes.registerType("SetVoltage", SetVoltage);
}