module.exports = Optosense = require('bindings')('../nodes/Optosense');
const exec = require('util').promisify(require('child_process').exec);

module.exports.SPI = {
    MODE_DEFAULT:   0x00,
    MODE_CPHA:      0x01,
    MODE_CPOL:      0x02,
    MODE_CPOLHA:    0x03,

    MSB_FIRST: 0x00,
    LSB_FIRST: 0x01,
};

module.exports.BUS = {
    Self:     0x00,
    CHARGER:  0x01,
    GAUGE:    0x02,
};

module.exports.Command = {
    DISABLE_5V_12V_POWER:   0x00,
    ENABLE_5V_12V_POWER:    0x01,
    SET_5V_12V_POWER:       0x02,
    SystemReset:            0x03,
    BatteryShutdown:        0x04,
};

module.exports.SPI_DEVICE  = "/dev/spidev0.1";
module.exports.SPI_SPEED   = 1000;

module.exports.Core =
{
    CMD: function(DeviceSelector, Register_Or_Command, Param_Data, Param_ReadLen, cb) 
    {
        Optosense.Transfer(Optosense.SPI_DEVICE, Optosense.SPI_SPEED, Optosense.SPI.MODE_DEFAULT, Optosense.SPI.MSB_FIRST, Buffer.from([DeviceSelector, Register_Or_Command, Param_Data, Param_ReadLen, 0, 0, 0, 0 /* last 4 byte are dummy bytes do not remove them */]), Param_ReadLen, cb);
        return this;	
    }
}

module.exports.Misc =
{
    minsToHHMMSS:function (val) 
    {
        var mins_num = parseFloat(val, 10); // don't forget the second param
        var hours   = Math.floor(mins_num / 60);
        var minutes = Math.floor((mins_num - ((hours * 3600)) / 60));
        var seconds = Math.floor((mins_num * 60) - (hours * 3600) - (minutes * 60));
    
        // Appends 0 when unit is less than 10
        if (hours   < 10) {hours   = "0"+hours;}
        if (minutes < 10) {minutes = "0"+minutes;}
        if (seconds < 10) {seconds = "0"+seconds;}
        return hours+':'+minutes+':'+seconds;
    }
}